import sys
import numpy as np
import scipy.linalg as linalg

n = len(sys.argv)

if n != 2 :
	print("Args: nombre_archivo")
	sys.exit(1)

P = np.loadtxt( sys.argv[1] )
# print( P.shape )

vx = np.zeros( (6,1) )

D = np.zeros( (6,6 ) )

n, m = P.shape

i = 0
while i < n :
	x = P[i][0]
	y = P[i][1]

	vx[0,0] = x*x
	vx[1,0] = x*y
	vx[2,0] = y*y
	vx[3,0] = x
	vx[4,0] = y
	vx[5,0] = 1.0

	D += vx @ vx.T
	#   6x1   1x6 = 6x6

	i += 1

C = np.zeros( (6,6) )
C[0,2] = -2.0
C[1,1] =  1.0
C[2,0] = -2.0

ve, E = linalg.eig( D, C )

print( "ve:" )
print( ve )
# print( type(ve[0]) )

print( "E:" )
print( E )

imin =  np.argmin( ve )
# print( imin )
solucion = E[:,imin]
a = solucion[0]
b = solucion[1]
c = solucion[2]
d = solucion[3]
e = solucion[4]
g = solucion[5]
print( a, b, c, d, e, g )
