import sys
import numpy as np
import scipy.linalg as linalg

n = len(sys.argv)

if n != 2 :
	print("Args: nombre_archivo")
	sys.exit(1)

P = np.loadtxt( sys.argv[1] )

vx = np.zeros( (6,1) )

D = np.zeros( (6,6 ) )

n, m = P.shape
# print( n )
i = 0
while i < n :
	x = P[i,0]
	y = P[i,1]
	# print( x, y )
	i += 1

i = 0
while i < n :
	x = P[i][0]
	y = P[i][1]

	vx[0,0] = x*x
	vx[1,0] = x*y
	vx[2,0] = y*y
	vx[3,0] = x
	vx[4,0] = y
	vx[5,0] = 1.0

	D += vx @ vx.T
	#   6x1   1x6 = 6x6

	i += 1

S1 = np.zeros( (3,3) )
S2 = np.zeros( (3,3) )
S3 = np.zeros( (3,3) )

S1 = D[0:3,0:3]
S2 = D[0:3,3:6]
S3 = D[3:6,3:6]

C1 = np.zeros( (3,3) )
C1[0,2] =  2.0
C1[1,1] = -1.0
C1[2,0] =  2.0

# a2 = - S3^{-1} S2^T a1
# (S1 - S2 S3^{-1} S2^T ) a1 = l C1 a1
S3inv = linalg.inv( S3 )

D1 = S1 - S2 @ S3inv @ S2.T

ve, E = linalg.eig( D1, C1 )

# print( "ve:" )
# print( ve )
# print( type(ve[0]) )

# print( "E:" )
# print( E )

imin = np.argmax( ve )
# print( imin )
a1 = E[:,imin]

a2 = - S3inv @ S2.T @ a1

a = a1[0]
b = a1[1]
c = a1[2]
d = a2[0]
e = a2[1]
g = a2[2]
print( a, b, c, d, e, g )
